/******************************************************************************
 *
 *  Copyright 2022 NXP
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 ******************************************************************************/
#pragma once

typedef uint8_t nfc_event_t;
typedef uint8_t nfc_status_t;

/*
 * The callback passed in from the NFC stack that the HAL
 * can use to pass events back to the stack.
 */
typedef void(nfc_stack_callback_t)(nfc_event_t event,
                                   nfc_status_t event_status);

/*
 * The callback passed in from the NFC stack that the HAL
 * can use to pass incoming data to the stack.
 */
typedef void(nfc_stack_data_callback_t)(uint16_t data_len, uint8_t* p_data);
